function [fval] = brown(x)
% [fval] = brown(x) returns the value of Brown's almost linear 
% function at x.
% RBK 11/15/2005

n = size(x,1)
fval = zeros(n,1)
sumj = 0;
prodj = 1;
for j=1:n
    sumj = sumj + x(j);
    prodj = prodj*x(j);
end
sumj = sumj - n - 1;
fval(n) = prodj-1;
for i = 1:n-1
    fval(i) = x(i) + sumj;
end
    