function [xi1, xi2, there_are_2, is_empty, is_different] ... 
    = extended_intersect_with_2(x1, x2, there_are_2_x,...
                                y1, y2, there_are_2_y)
% RBK December 14, 2005 --
% [xi1, xi2, there_are_2, is_empty, is_different] ...
%    = extended_intersect_with_2(x1, x2, there_are_2_x, ...
%                                y1, y2, there_are_2_y)
% Computes the intersection of one or two intervals x1 
% (and possibly x2) with one or two
% (possibly semi-infinite) intervals y1 and y2.  
% there_are_2_x should be set to 1 if both x1 and x2 are to
% be used, whereas there_are_2 should be set to 0 otherwise.

if (~there_are_2_x) 
    [xi1, xi2, there_are_2, is_empty, is_different] ... 
      = extended_intersect(x1, y1, y2, there_are_2_y);
else
    [xi11, xi12, there_are_2_1, is_empty_1, is_different_1] ... 
          = extended_intersect(x1, y1, y2, there_are_2_y);
    if(is_empty_1)
        total_number = 0;
    elseif(there_are_2_1)
        is_empty = 0;
        there_are_2 = 1;
        is_different = 1;
        total_number = 2;
        xi1 = xi11;
        xi2 = xi12;
    else
        total_number = 1;
        xi1 = xi11;
    end
        
    [xi21, xi22, there_are_2_2, is_empty_2, is_different_2] ... 
          = extended_intersect(x2, y1, y2, there_are_2_y);
    switch(total_number)
        case(0)
            is_empty = is_empty_2;
            there_are_2 = there_are_2_1;
            is_different = 1;
            xi1 = xi21;
            xi2 = xi22;
        case(1)
            if(is_empty_2)
                is_empty = 0;
                there_are_2 = 0;
                is_different = 1;
                xi2 = x2;
            else
                is_empty = 0;
                if (there_are_2_2)
                    blooper = oops;
                else
                    is_empty = 0;
                    there_are_2 = 1;
                    is_different = is_different_1 | is_different_2;
                    xi2 = xi21;
                end
            end
        case(2)
            if(~is_empty_2)
               fprintf(1,'More than two intervals were produced in ');
               fprintf(1,'extended_intersect_with_2\n');
               xi1 = x1;
               xi2 = x2;
               is_empty = 0;
               there_are_2 = 1;
               is_different = 0;
            end
        otherwise
            fprintf(1,'Error in extended_intersect_with_2:\n');
            fprintf(1,'total_number = %4.0f',total_number);
    end
end
        
    

            